import { JSX } from 'solid-js/jsx-runtime';
import { CodeMirrorProps } from '@solid-codemirror/core';
import { Extension } from '@codemirror/state';

interface LineNumbersProps {
    /**
     * Whether to display line numbers
     * @default true
     */
    showLineNumbers?: boolean;
}

interface ReadOnlyProps {
    /**
     * Whether to set the editor to read-only
     * @default false
     */
    readOnly?: boolean;
}

interface WrapLineProps {
    /**
     * Whether to wrap lines
     * @default false
     */
    wrapLine?: boolean;
}

interface ExtensionsProps {
    /**
     * An array of CodeMirror extensions to use
     */
    extensions?: Extension[];
}

interface ThemeProps {
    /**
     * The CodeMirror theme extension to use
     */
    theme?: Extension;
}

declare type Props = CodeMirrorProps & LineNumbersProps & ReadOnlyProps & WrapLineProps & ExtensionsProps & ThemeProps & JSX.HTMLAttributes<HTMLDivElement>;
declare function CodeMirror(props: Props): JSX.Element;

export { CodeMirror, Props };
